/*
 * Copyright (c) 2016 Samsung Electronics Co., Ltd
 *
 * Licensed under the Flora License, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://floralicense.org/license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#if !defined(_TYPES_H)
#define _TYPES_H

#define DISP_MAX_DIGITS 12
#define DISP_STR_SIZE 251

#define KEY_TYPE_MASK 0xFF00
#define KEY_TYPE_NUM 0x0100
#define KEY_TYPE_OP 0x0200

typedef void (*display_changed_cb)(void);

typedef enum {
	RES_OK = 0,
	RES_MAX_DIGITS_REACHED = 1,
	RES_DOUBLE_DOT = 2,
	RES_DISPLAY_IS_EMPTY = 3,
	RES_FAIL = -1,
	RES_OUT_OF_MEMORY = -2,
	RES_ILLEGAL_ARGUMENT = -3,
	RES_ILLEGAL_STATE = -4,
	RES_INTERNAL_ERROR = -5,
	RES_NUMER_IS_TOO_LONG = -6,
	RES_DIVISION_BY_ZERO = -7,
	RES_UNDEFINED_VALUE = -8
} result_type;

typedef enum {
	KEY_NONE = 0,
	KEY_RESULT = 1,
	KEY_SIGN = 2,
	KEY_ERASE = 3,
	KEY_RESET = 4,
	KEY_0 = KEY_TYPE_NUM | 0,
	KEY_1 = KEY_TYPE_NUM | 1,
	KEY_2 = KEY_TYPE_NUM | 2,
	KEY_3 = KEY_TYPE_NUM | 3,
	KEY_4 = KEY_TYPE_NUM | 4,
	KEY_5 = KEY_TYPE_NUM | 5,
	KEY_6 = KEY_TYPE_NUM | 6,
	KEY_7 = KEY_TYPE_NUM | 7,
	KEY_8 = KEY_TYPE_NUM | 8,
	KEY_9 = KEY_TYPE_NUM | 9,
	KEY_DEC = KEY_TYPE_NUM | 10,
	KEY_ADD = KEY_TYPE_OP | 0,
	KEY_SUB = KEY_TYPE_OP | 1,
	KEY_MUL = KEY_TYPE_OP | 2,
	KEY_DIV = KEY_TYPE_OP | 3
} key_type;

#endif
